#include <Wire.h>
#include <LiquidCrystal_I2C_Ext.h>
LiquidCrystal_I2C_Ext lcd(0x27, 20, 4);

// Пины для энкодера
#define pinCLK 2
#define pinDT  3
#define pinSW  4

int x = 0; // Счетчик

void setup() {
  lcd.begin();
  lcd.attachEncoder(pinDT, pinCLK, pinSW);
  lcd.printfAt(0, 0, "%d ", x);
}

void loop() {
  // Опрашиваем состояние энкодера
  eEncoderState EncoderState = lcd.getEncoderState();
  switch (EncoderState) {
    case eLeft: // При вращении влево уменьшаем счетчик
      x--;
      break;
    case eRight: // При вращении вправо увеличиваем счетчик
      x++;
      break;
    case eButton: // При нажатии обнуляем
      x = 0;
      break;
    case eNone: // Состояие энкодера не изменилось. Выходим из функции
      return;
  }
  lcd.printfAt(0, 0, "%d ", x); // Выводим значение счетчика на дисплей
}
