#include <Wire.h>
#include <LiquidCrystal_I2C_Ext.h>
LiquidCrystal_I2C_Ext lcd(0x27, 20, 4);

// Пины для энкодера
#define pinCLK 2
#define pinDT  3
#define pinSW  4

void setup() {
  lcd.begin();
  lcd.attachEncoder(pinDT, pinCLK, pinSW);
}

void loop() {
  // Примеры использования функций ввода
  double x = 0;
  long y = 0;
  
  // inputVal(title, min, max, default, [step = 1])
  // inputValBitwise(title, value, precision, [scale = 0], [signed = 0])

  x = lcd.inputVal("Input value", 0.0, 10.0, x, 0.25); // ввод double от 0 до 10 с шагом 0.25
  x = lcd.inputVal<double>("Input value", 0, 10, x, 0.25); // вызов аналогичен предыдущей записи, но тип переменных указан явно - <double>
  lcd.inputValBitwise("Input value", x, 4, 2, 0); // ввод значения XX.XX без знака
  lcd.inputValBitwise("Input value", x, 4, 2, 1); // ввод значения [-]XX.XX

  y = lcd.inputVal <long> ("Input value", 0, 10000, y, 100); // ввод long. Тип переменной указан явно, чтобы не было ошибки при компиляции
  lcd.inputValBitwise("Input value", y, 4); // ввод 4-х значного значения (scale и signed по умолчанию = 0)
  lcd.inputValBitwise("Input value", y, 4, 0, 1); // ввод 4-х значного значения со знаком
}
