#include <avr/pgmspace.h>
#include <Wire.h>
#include <LiquidCrystal_I2C_Ext.h>
LiquidCrystal_I2C_Ext lcd(0x27, 20, 4);

// Пины для энкодера
#define pinCLK 2
#define pinDT  3
#define pinSW  4

const char text_1[] PROGMEM = "Using PROGMEM example";
const char text_2[] PROGMEM = "This text is stored in FLASH";

const char* const text[] PROGMEM = {text_1, text_2};

void setup() {
  lcd.begin();
  lcd.attachEncoder(pinDT, pinCLK, pinSW);
}

void loop() {
  char *buffer;
  lcd.printMultiline("Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua");
  buffer = (char*) malloc(30); // Выделяем память для чтения строки из памяти программ
  strcpy_P(buffer, (char*)pgm_read_word(&(text[0]))); // Считываем строку из памяти программ
  lcd.printMultiline(buffer); // Выводим содержимое буфера на экран
  strcpy_P(buffer, (char*)pgm_read_word(&(text[1])));
  lcd.printMultiline(buffer);
  free(buffer); // И освобождаем буфер
  lcd.printMultiline(F("Using F() macro example. Press button to continue."));
}
